package com.sa.ibiz.demo.demo.rest;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.sa.ibiz.demo.demo.domain.WFVersion;
import com.sa.ibiz.demo.demo.service.WFVersionService;
import com.sa.ibiz.demo.demo.service.dto.WFVersionSearchFilter;
import com.sa.ibiz.demo.ibizutil.errors.BadRequestAlertException;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.ResponseEntity;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.*;
import java.math.BigInteger;
import java.util.List;

@RestController
@RequestMapping("/demo/wfversion")
public class WFVersionResource
{
	@Autowired
	private WFVersionService service;


	@PostMapping(value = "/checkKey")
	public ResponseEntity<WFVersion> checkKey(@Validated @RequestBody WFVersion data){
		boolean bRt=service.checkKey(data);
		if(!bRt)
			throw new BadRequestAlertException("工作流配置版本[checkKey]操作发生错误","WFVersion",data.getWfversionid().toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/create")
	public ResponseEntity<WFVersion> create(@Validated @RequestBody WFVersion data){
		boolean bRt=service.create(data);
		if(!bRt)
			throw new BadRequestAlertException("工作流配置版本[create]操作发生错误","WFVersion",data.getWfversionid().toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/remove")
	public ResponseEntity<WFVersion> remove(@Validated @RequestBody WFVersion data){
		boolean bRt=service.remove(data);
		if(!bRt)
			throw new BadRequestAlertException("工作流配置版本[remove]操作发生错误","WFVersion",data.getWfversionid().toString());
		return ResponseEntity.ok().body(data);
	}
	@GetMapping(value = "/{id}")
	public ResponseEntity<WFVersion> get(@Validated @PathVariable String id){
		WFVersion data=new WFVersion();
		data.setWfversionid(id);;
		data=service.get(data);
		if(data==null)
			throw new BadRequestAlertException("工作流配置版本[get]操作发生错误","WFVersion",id.toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/update")
	public ResponseEntity<WFVersion> update(@Validated @RequestBody WFVersion data){
		boolean bRt=service.update(data);
		if(!bRt)
			throw new BadRequestAlertException("工作流配置版本[update]操作发生错误","WFVersion",data.getWfversionid().toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/getDraft")
	public ResponseEntity<WFVersion> getDraft(@Validated @RequestBody WFVersion data){
		boolean bRt=service.getDraft(data);
		if(!bRt)
			throw new BadRequestAlertException("工作流配置版本[getDraft]操作发生错误","WFVersion","");
		return ResponseEntity.ok().body(data);
	}
    @PostMapping(value="/searchdefault")
	public ResponseEntity<Page<WFVersion>> searchDefaultPage(@Validated @RequestBody WFVersionSearchFilter filter){
		Page<WFVersion> searchResult = service.searchDefault(filter);
		return ResponseEntity.ok().body(searchResult);
	}

	@PostMapping(value="/listdefault")
	public ResponseEntity<List<WFVersion>> listDefault(@Validated @RequestBody WFVersionSearchFilter filter){
		List<WFVersion> searchResult = service.listDefault(filter);
		return ResponseEntity.ok().body(searchResult);
	}
}
